﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=8.1
@EndOfDesignText@
'Static code module

'Return true to allow the default exceptions handler to handle the uncaught exception.
Sub Application_Error (Error As Exception, StackTrace As String) As Boolean
	Return True
End Sub

'Globals
Sub Process_Globals
	Private fx As JFX
	Private MainForm As Form
	
	'Button
	Private btnAdd, btnSub, btnMult, btnDiv, btnAll  As Button
	Private btnAction, btn0, OldButton, OldLevelBTN As Button
	Private btnClicker As Button
	Private btnHint As Button
	Private btnClear As Button
	Private btnEasy As Button
	Private btnMed As Button
	Private btnHard As Button
	
	'Label
	Private lblComments, lblMathSign, lblNumber1, lblNumber2, lblResult As Label
	Private lblNumCorrect, lblNumWrong, lblCAddTotal, lblCSubTotal, lblCMultTotal As Label
	Private lblCDivTotal, lblWDivTotal, lblWAddTotal, lblWSubTotal,lblWMultTotal  As Label
	Private lblStreakNumber As Label
	
	'MediaPlayer
	Private mpRight As MediaPlayer	'For Sound Files
	Private mpWrong As MediaPlayer
	
	'Boolean
	Private IsCorrect As Boolean = True
	
	'Int
	Private Level As Int
	Private StreakNumber As Int
	Private Number1, Number2, NumCorrect = 0, NumWrong = 0, PracticeNumber = 4 As Int
	Private CAddTotal = 0, CSubTotal = 0, CMulTotal = 0, CDivTotal = 0 As Int
	Private WAddTotal = 0, WSubTotal = 0, WMulTotal = 0, WDivTotal = 0 As Int
	
	Private MathSign(5) As String = Array As String("+","-","X","/","A")
	
	'Shared Variables
	Public HStreakNum As Int
	Public lblHStreakNum As Label
	
End Sub

'Display the Math Trainer Screen
Public Sub Show
	If MainForm.IsInitialized = False Then
		
		'Load Math Trainer Screen
		MainForm.Initialize("MainForm", 625, 625)
		MainForm.Resizable = False
		MainForm.RootPane.LoadLayout("layMathTrainer")
		
		'Initialize Sound Files
		mpRight.Initialize("mpRight", File.GetUri(File.DirAssets,"win.mp3"))	
		mpWrong.Initialize("mpWrong", File.GetUri(File.DirAssets,"lose.mp3"))
	
		'Set the initial values
		lblMathSign.Text = MathSign(4)
		OldLevelBTN = btnEasy
		OldButton = btnAll
		btnHint.Visible = False
		btnAction.Text = "N E W"
		lblComments.Text = "Select Level" & CRLF & "Select Type" & CRLF & "Click on NEW"
		CSSUtils.SetBackgroundColor(lblComments, fx.Colors.RGB(255,235,128)) 'yellow color
		lblNumber1.Text = "3"
		lblMathSign.Text = "X"
		lblNumber2.Text = "5"
		lblResult.Text = "15"
		Level = 10
		
	End If
	
	lblHStreakNum.Text = HStreakNum
	MainForm.Show
	
End Sub

'Displays the Multiplication Tables
Sub btnHint_MouseClicked (EventData As MouseEvent)
	MultTable.Show
'	MainForm.Close
End Sub

'Displays a new problem based on the practice mode selected
Private Sub NewProblem
	Private TempNumber As Int
	
	If PracticeNumber = 4 Then
		TempNumber = Rnd(0,4)				'Generates a random number between 0 and 3 Representing the type of math problem
	Else
		TempNumber = PracticeNumber
	End If
	
	If (TempNumber = 2 Or TempNumber = 3) And IsCorrect = False Then' Mistake Then
		btnHint.Visible = True
	Else
		btnHint.Visible = False
	End If
	
	lblMathSign.Text = MathSign(TempNumber) ' Assigns the current Math Operation to the Label
	If TempNumber = 1 Then
		btn0.Visible = True
	Else
		btn0.Visible = False
	End If
	Number1 = Rnd(1, Level)			' Generates a random number between 1 and 9
	Number2 = Rnd(1, Level)			' Generates a random number between 1 and 9
	
	Select lblMathSign.Text
		Case "-"
			If Number1 < Number2 Then	'Make the larger number first if subtracting to keep the answers positive
				TempNumber = Number1
				Number1 = Number2
				Number2= TempNumber
			End If
		Case "/"						'Make the first number number1 * number2 so the answer is evenly divisible
			TempNumber = Number1 * Number2
			Number1 = TempNumber
	End Select

	lblNumber1.Text = Number1		' Displays Number1 in label lblNumber1
	lblNumber2.Text = Number2		' Displays Number2 in label lblNumber2
	CSSUtils.SetBackgroundColor(lblComments, fx.Colors.RGB(255,235,128)) 'yellow color
	lblComments.Text = "Enter the result" & CRLF & "and click on OK"
	lblResult.Text = ""			' Sets edtResult.Text to empty

	If lblMathSign.Text = "-" Then 'Show button 0 if a subtraction equation
		btn0.Visible = True
	Else
		btn0.Visible = False
	End If
End Sub

'Handles both right and wrong answers
Private Sub CheckResult
	IsCorrect = True
	Select lblMathSign.Text
		Case "+"
			If lblResult.Text = Number1 + Number2 Then
				IsCorrect = True
				CAddTotal = CAddTotal + 1
				lblCAddTotal.text =  CAddTotal
			Else
				WAddTotal = WAddTotal + 1
				lblWAddTotal.Text = WAddTotal
				IsCorrect = False
				If Level < 20 Then
					btnHint.Visible = True
				End If
			End If
		Case "-"
			If lblResult.Text = Number1 - Number2 Then
				CSubTotal = CSubTotal + 1
				lblCSubTotal.Text = CSubTotal
			Else
				WSubTotal = WSubTotal + 1
				lblWSubTotal.Text = WSubTotal
				IsCorrect = False
				If Level < 20 Then
					btnHint.Visible = True
				End If
			End If
		Case "X"
			If lblResult.Text = Number1 * Number2 Then
				CMulTotal = CMulTotal + 1
				lblCMultTotal.Text = CMulTotal
			Else
				WMulTotal = WMulTotal + 1
				lblWMultTotal.Text = WMulTotal
				IsCorrect = False
				If Level < 20 Then
					btnHint.Visible = True
				End If
			End If
		Case "/"			
			If lblResult.Text = Number1 / Number2 Then
				IsCorrect = True
				CDivTotal = CDivTotal + 1
				lblCDivTotal.Text = CDivTotal
			Else
				WDivTotal = WDivTotal + 1
				lblWDivTotal.Text = WDivTotal
				IsCorrect = False
				If Level < 20 Then
					btnHint.Visible = True
				End If
			End If
	End Select
	
	
	If IsCorrect Then
		StreakNumber = StreakNumber + 1
		If HStreakNum < StreakNumber Then
			HStreakNum = StreakNumber
			LogIn.SaveUserStats
		End If
	Else
		StreakNumber = 0
	End If
	
	lblStreakNumber.Text = StreakNumber 'Update Streak Number
	lblHStreakNum.Text = HStreakNum
	
	If IsCorrect Then
		mpRight.Stop : mpRight.Play	'Play Correct Sound
		CSSUtils.SetBackgroundColor(lblComments, fx.Colors.RGB(128,255,128)) ' light green color
		lblComments.Text = "G O O D  result" & CRLF & "Click on NEW"
		btnAction.Text = "N E W"
		NumCorrect = NumCorrect + 1
		lblNumCorrect.Text = NumCorrect
	Else
		mpWrong.Stop : mpWrong.Play	'Play Wrond Sound
		CSSUtils.SetBackgroundColor(lblComments, fx.Colors.RGB(255,128,128)) ' light red color
		lblComments.Text = "W R O N G  result" & CRLF & "Enter a new result" & CRLF & "and click OK"
		lblResult.Text = ""			' Sets edtResult.Text to empty
		NumWrong = NumWrong + 1
		lblNumWrong.Text = NumWrong
	End If
End Sub

'Displays the numbers selected
Private Sub btnEvent_MouseClicked (EventData As MouseEvent)
	Private btnSender As Button
	
	btnSender = Sender
	
	If btnAction.Text <> "N E W" Then	
		Select btnSender.Tag
		
			Case "BS"					'Erase the last number if Backspace was selected
				If lblResult.Text.Length > 0 Then
					lblResult.Text = lblResult.Text.SubString2(0, lblResult.Text.Length -1)
				End If
			Case "Clr"
				lblResult.Text = ""
			Case Else
				lblResult.Text = lblResult.Text & btnSender.Text
		End Select
		
		If lblResult.Text.Length = 0 Then
			btn0.Visible = False
		Else
			btn0.Visible = True
		End If

	End If
End Sub

'Handles Nothing Entered, Calls CheckResult or NewProblem
Sub btnAction_Click
	If btnAction.Text = "O K" Then
		If lblResult.Text="" Then	'Nothing was entered
			lblComments.Text = "No result entered" & CRLF & "Enter a result" & CRLF & "and click on OK"
		Else
			CheckResult	'Checks to see if the answer is correct
		End If
	Else
		NewProblem
		btnAction.Text = "O K"
		lblResult.Text = ""
	End If
End Sub


'' Changes background colors if Addition is Selected
'Sub btnAdd_Click
'	CSSUtils.SetBackgroundColor(OldButton, fx.Colors.White)
'	CSSUtils.SetBackgroundColor(btnAdd, fx.Colors.LightGray)
'	OldButton = btnAdd
'	PracticeNumber = 0
'End Sub
'
'' Changes background colors if Subtraction is Selected
'Sub btnSub_Click
'	CSSUtils.SetBackgroundColor(OldButton, fx.Colors.White)
'	CSSUtils.SetBackgroundColor(btnSub, fx.Colors.LightGray)
'	OldButton = btnSub
'	PracticeNumber = 1
'End Sub
'
'' Changes background colors if Multiplication is Selected
'Sub btnMult_Click
'	CSSUtils.SetBackgroundColor(OldButton, fx.Colors.White)
'	CSSUtils.SetBackgroundColor(btnMult, fx.Colors.LightGray)
'	OldButton = btnMult
'	PracticeNumber = 2
'End Sub
'
'' Changes background colors if Division is Selected
'Sub btnDiv_Click
'	CSSUtils.SetBackgroundColor(OldButton, fx.Colors.White)
'	CSSUtils.SetBackgroundColor(btnDiv, fx.Colors.LightGray)
'	OldButton = btnDiv
'	PracticeNumber = 3
'End Sub

Sub btnEasy_Click
	CSSUtils.SetBackgroundColor(OldLevelBTN, fx.Colors.White)
	CSSUtils.SetBackgroundColor(btnEasy, fx.Colors.LightGray)
	OldLevelBTN = btnEasy
	Level = 10
End Sub

Sub btnMed_Click
	CSSUtils.SetBackgroundColor(OldLevelBTN, fx.Colors.White)
	CSSUtils.SetBackgroundColor(btnMed, fx.Colors.LightGray)
	OldLevelBTN = btnMed
	Level = 20
End Sub

Sub btnHard_Click
	CSSUtils.SetBackgroundColor(OldLevelBTN, fx.Colors.White)
	CSSUtils.SetBackgroundColor(btnHard, fx.Colors.LightGray)
	OldLevelBTN = btnHard
	Level = 30
End Sub

Sub btnScratchPad_Click
	ScratchPad.Show
End Sub

Sub btnClicker_Click
	ClickCounter.Show
End Sub

'Reset Streak Numbers to zero
Sub btnReset_Click
	HStreakNum = 0
	lblHStreakNum.Text = HStreakNum 'Update High Streak Number
	StreakNumber = 0
	lblStreakNumber.Text = StreakNumber 'Update Streak Number
	LogIn.SaveUserStats
End Sub

'' Changes background colors if All is Selected
'Sub btnAll_Click
'	CSSUtils.SetBackgroundColor(OldButton, fx.Colors.White)

''	CSSUtils.SetBackgroundColor(btnAll, fx.Colors.LightGray)
'	CSSUtils.SetBackgroundColor(Sender, fx.Colors.LightGray)

''	OldButton = btnAll
'	OldButton = Sender

''	PracticeNumber = 4
'	PracticeNumber = OldButton.Tag
'End Sub
'
'=============================================================================
'I have five buttons that use this event, four work and one button only sends
'The information for the last button pressed
'Button All is not changing the Sender, it is sending the code for the last button pressed
'
Sub PracticeMode_Click
	Log(Sender)
	CSSUtils.SetBackgroundColor(OldButton, fx.Colors.White)
	CSSUtils.SetBackgroundColor(Sender, fx.Colors.LightGray)
	OldButton = Sender
	PracticeNumber = OldButton.Tag
End Sub


